Index: data/trunk/materials/Glasstower1.material
===================================================================
--- data/trunk/materials/Glasstower1.material	(revision 10862)
+++ data/trunk/materials/Glasstower1.material	(revision 10862)
@@ -0,0 +1,42 @@
+// Glasstower1 genrated by blender2ogre 0.6.0
+
+material Glasstower1 
+{
+    receive_shadows on 
+
+    technique
+    {
+        pass Glasstower1
+        {
+            ambient 0.800000011920929 0.800000011920929 0.800000011920929 1.0
+            diffuse 0.800000011920929 0.800000011920929 0.800000011920929 1.0
+            specular 0.0 0.0 0.0 1.0 12.5
+            emissive 0.0 0.0 0.0 1.0
+
+            alpha_to_coverage off
+            colour_write on
+            cull_hardware clockwise
+            depth_check on
+            depth_func less_equal
+            depth_write on
+            illumination_stage 
+            light_clip_planes off
+            light_scissor off
+            lighting on
+            normalise_normals off
+            polygon_mode solid
+            scene_blend one zero
+            scene_blend_op add
+            shading gouraud
+            transparent_sorting on
+
+            texture_unit 
+            {
+                texture Glasstower1.jpg
+                tex_address_mode wrap
+                scale 1.0 1.0
+                colour_op modulate
+            }
+        }
+    }
+}
Index: data/trunk/materials/Hausc1.material
===================================================================
--- data/trunk/materials/Hausc1.material	(revision 10862)
+++ data/trunk/materials/Hausc1.material	(revision 10862)
@@ -0,0 +1,42 @@
+// Hausc1 genrated by blender2ogre 0.6.0
+
+material Hausc1 
+{
+    receive_shadows on 
+
+    technique
+    {
+        pass Hausc1
+        {
+            ambient 0.800000011920929 0.800000011920929 0.800000011920929 1.0
+            diffuse 0.6400000190734865 0.6400000190734865 0.6400000190734865 1.0
+            specular 0.5 0.5 0.5 1.0 12.5
+            emissive 0.0 0.0 0.0 1.0
+
+            alpha_to_coverage off
+            colour_write on
+            cull_hardware clockwise
+            depth_check on
+            depth_func less_equal
+            depth_write on
+            illumination_stage 
+            light_clip_planes off
+            light_scissor off
+            lighting on
+            normalise_normals off
+            polygon_mode solid
+            scene_blend one zero
+            scene_blend_op add
+            shading gouraud
+            transparent_sorting on
+
+            texture_unit 
+            {
+                texture hausc1.png
+                tex_address_mode wrap
+                scale 1.0 1.0
+                colour_op modulate
+            }
+        }
+    }
+}
Index: data/trunk/materials/PrimeTower.material
===================================================================
--- data/trunk/materials/PrimeTower.material	(revision 10862)
+++ data/trunk/materials/PrimeTower.material	(revision 10862)
@@ -0,0 +1,43 @@
+// PrimeTower genrated by blender2ogre 0.6.0
+
+material PrimeTower 
+{
+    receive_shadows on 
+
+    technique
+    {
+        pass PrimeTower
+        {
+            ambient 0.800000011920929 0.800000011920929 0.800000011920929 1.0
+            diffuse 0.6400000190734865 0.6400000190734865 0.6400000190734865 1.0
+            specular 0.5 0.5 0.5 1.0 12.5
+            emissive 0.0 0.0 0.0 1.0
+
+            alpha_to_coverage off
+            colour_write on
+            cull_hardware clockwise
+            depth_check on
+            depth_func less_equal
+            depth_write on
+            illumination_stage 
+            light_clip_planes off
+            light_scissor off
+            lighting on
+            normalise_normals off
+            polygon_mode solid
+            scene_blend one zero
+            scene_blend_op add
+            shading gouraud
+            transparent_sorting on
+
+            texture_unit 
+            {
+                texture prim.png
+                tex_address_mode wrap
+                scale 1.0 1.0
+                tex_coord_set 0
+                colour_op modulate
+            }
+        }
+    }
+}
Index: data/trunk/materials/ethnew.material
===================================================================
--- data/trunk/materials/ethnew.material	(revision 10862)
+++ data/trunk/materials/ethnew.material	(revision 10862)
@@ -0,0 +1,43 @@
+// ethnew genrated by blender2ogre 0.6.0
+
+material ethnew 
+{
+    receive_shadows on 
+
+    technique
+    {
+        pass ethnew
+        {
+            ambient 0.800000011920929 0.800000011920929 0.800000011920929 1.0
+            diffuse 0.6400000190734865 0.6400000190734865 0.6400000190734865 1.0
+            specular 0.5 0.5 0.5 1.0 12.5
+            emissive 0.0 0.0 0.0 1.0
+
+            alpha_to_coverage off
+            colour_write on
+            cull_hardware clockwise
+            depth_check on
+            depth_func less_equal
+            depth_write on
+            illumination_stage 
+            light_clip_planes off
+            light_scissor off
+            lighting on
+            normalise_normals off
+            polygon_mode solid
+            scene_blend one zero
+            scene_blend_op add
+            shading gouraud
+            transparent_sorting on
+
+            texture_unit 
+            {
+                texture ETHNEW.png
+                tex_address_mode wrap
+                scale 1.0 1.0
+                tex_coord_set 1
+                colour_op modulate
+            }
+        }
+    }
+}