Index: code/branches/campaignHS15/src/orxonox/controllers/CommonController.h
===================================================================
--- code/branches/campaignHS15/src/orxonox/controllers/CommonController.h	(revision 10861)
+++ code/branches/campaignHS15/src/orxonox/controllers/CommonController.h	(revision 10864)
@@ -61,20 +61,5 @@
 
     }
-    namespace Action
-    {  
-        enum Value
-        {
-            NONE, FLY, FIGHT, PROTECT, FIGHTALL, ATTACK
-        };
-        
-    }
-    
-    struct Point {
-        Action::Value action;
-        std::string name;
-        Vector3 position;
-        bool inLoop;
-    } ;
-
+   
 
     
@@ -96,14 +81,13 @@
                 virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
                 
-                    void setFormationModeXML(std::string val);
-                    std::string getFormationModeXML();
-                    void setFormationMode(FormationMode::Value val);
-                    FormationMode::Value getFormationMode() const;
+                void setFormationModeXML(std::string val);
+                std::string getFormationModeXML();
+                void setFormationMode(FormationMode::Value val);
+                FormationMode::Value getFormationMode() const;
 
-                    void setRank(Rank::Value val);
-                    Rank::Value getRank() const;
-               
-                    void addActionpoint(WorldEntity* waypoint);
-                    WorldEntity* getActionpoint(unsigned int index) const;
+                void setRank(Rank::Value val);
+                Rank::Value getRank() const;
+           
+
             //----[/XML methods]----
 
@@ -115,12 +99,5 @@
                 ControllableEntity* getTarget();
                       
-                Action::Value getAction ();
-                std::string getActionName();
-
-                void setAction (Action::Value action);
-                void setAction (Action::Value action, ControllableEntity* target);
-                void setAction (Action::Value action, const Vector3& target);
-                void setAction (Action::Value action, const Vector3& target,  const Quaternion& orient );
-            //----[/Interaction with other Controllers]----
+             //----[/Interaction with other Controllers]----
 
             //----[Helper methods]----
@@ -135,9 +112,5 @@
             //----[/Helper methods]----
 
-             
-                virtual void stayNearProtect();
-                virtual void action(); //<! action() is called in regular intervals managing the bot's behaviour.
-                 virtual void takeActionpoints (std::vector<Point > vector, std::vector<Point > loop, bool b);
-   
+  
         protected:
             //----[Flying methods]----
@@ -168,6 +141,4 @@
                 void setOrientationOfTarget(const Quaternion& orient);
 
-                void setProtect (ControllableEntity* protect);
-                ControllableEntity* getProtect (); 
 
                 void maneuver();
@@ -175,7 +146,5 @@
                 bool canFire();
                 void doFire();
-                void setClosestTarget();
-                Pawn* closestTarget();
-                void startAttackingEnemiesThatAreClose();
+
             //----[/Fighting methods]----            
             
@@ -200,25 +169,9 @@
             //----[/who-to-kill information]----
 
-            //----[Actionpoint information]----
 
-                std::vector<WeakPtr<WorldEntity> > actionpoints_;
-                float squaredaccuracy_;
-                std::vector<Point > parsedActionpoints_;
-                std::vector<Point > loopActionpoints_;
-
-            //----[/Actionpoint information]----
-            //----[Actionpoint methods]----
-                void executeActionpoint();
-                void nextActionpoint();
-                void fillLoop();
-                void fillLoopReversed();
-                void moveBackToTop();
-            //----[Actionpoint methods]----
             //----["Private" variables]----
                 FormationMode::Value formationMode_;
                 Rank::Value rank_;
-                std::string protectName_;
-                std::string targetName_;
-                Action::Value action_;
+
                 int attackRange_;
                 bool bLookAtTarget_;        
@@ -227,8 +180,5 @@
                 int tolerance_; 
                 bool bFirstTick_; 
-                bool bInLoop_;
-                bool bLoop_;   
-                bool bEndLoop_;  
-                bool bTakenOver_;              
+            
             //----[/"Private" variables]----    
            