Index: code/branches/campaignHS15/data/levels/expeditionSector.oxw
===================================================================
--- code/branches/campaignHS15/data/levels/expeditionSector.oxw	(revision 10866)
+++ code/branches/campaignHS15/data/levels/expeditionSector.oxw	(revision 10867)
@@ -46,14 +46,20 @@
         cSpawn = {-50, 0, 0}
 
-	cStationA = {1400, 400, -800}	
+	      cStationA = {1400, 400, -800}
         cNewShip = {1000, 250, -350}
 
-	cPlanet1 = {-9000, -8000, 14000}
-	cPlanet2 = {12000, -1500, -10000}
-
-	cEnemyBasePlanet = {-20000, -5500, -8000}
-
-	cField1 = {-5000, -4000, -3000}
- 	cField2 = {4000, 2000, 4500}
+	      cPlanet1 = {-9000, -8000, 14000}
+	      cPlanet2 = {12000, -1500, -10000}
+
+      	cEnemyBasePlanet = {-20000, -5500, -8000}
+
+        cEnemyBaseStation1 = {-15000, -5000, -4000}
+        --[[
+        cEnemyBaseStation2 = {-16000, -5500, -4000}
+        cEnemyBaseStation3 = {-14000, -4500, -4000}
+        ]]--
+
+	      cField1 = {-5000, -4000, -3000}
+ 	      cField2 = {4000, 2000, 4500}
 
         --[[ Function to print Coordinates. Quotes not included! ]]--
@@ -227,4 +233,28 @@
     </Pawn>
 
+    <!-- EnemyStation -->
+
+    <Pawn name="statB" team=1 radarname="EnemyBase" position="<?lua printC(cEnemyBaseStation1) ?>" direction="<?lua printC(cSpawn) ?>" yaw=45 pitch=-5 roll=-25 initialhealth=10000 maxhealth=10000 >
+        <templates>
+            <Template link="station" />
+        </templates>
+    </Pawn>
+
+    <!--TODO: The Other Stations are flying away...
+
+    <Pawn name="statB" team=1 radarname="EnemyBase" position="<?lua printC(cEnemyBaseStation2) ?>" direction="<?lua printC(cSpawn) ?>" yaw=45 pitch=-5 roll=-25 initialhealth=10000 maxhealth=10000 >
+        <templates>
+            <Template link="station" />
+        </templates>
+    </Pawn>
+
+    <Pawn name="statB" team=1 radarname="EnemyBase" position="<?lua printC(cEnemyBaseStation3) ?>" direction="<?lua printC(cSpawn) ?>" yaw=45 pitch=-5 roll=-25 initialhealth=10000 maxhealth=10000 >
+        <templates>
+            <Template link="station" />
+        </templates>
+    </Pawn>
+
+  -->
+
     <!-- New SpaceShip as destination of dock A-->
     <SpaceShip
@@ -253,9 +283,9 @@
 
     <!-- Asteroids you have to fly through to get to the EnemyBase -->
-    
+
     <?lua
         dofile("includes/asteroidField.lua")
        asteroidField(cField1[1], cField1[2], cField1[3], 20, 30, 4500, 500, 0)
-    ?>    
+    ?>
 
     <!-- Other Asteroid-Fields -->
@@ -264,5 +294,5 @@
         dofile("includes/asteroidField.lua")
        asteroidField(cField2[1], cField2[2], cField2[3], 20, 30, 4500, 500, 0)
-    ?> 
+    ?>
 
     <!-- Planets -->
@@ -282,8 +312,8 @@
         atmospheresize="80.0f"
         imagesize="1024.0f"
-        collisiondamage = 2
-        enablecollisiondamage = true
-	visible=true
-	active=true
+        collisiondamage=2
+        enablecollisiondamage=true
+	      visible=true
+	      active=true
       >
       <attached>
@@ -314,8 +344,8 @@
         atmospheresize="80.0f"
         imagesize="1024.0f"
-        collisiondamage = 2
-        enablecollisiondamage = true
-	visible=true
-	active=true
+        collisiondamage=2
+        enablecollisiondamage=true
+	      visible=true
+	      active=true
       >
       <attached>
@@ -348,8 +378,8 @@
         atmospheresize="80.0f"
         imagesize="1024.0f"
-        collisiondamage = 2
-        enablecollisiondamage = true
-	visible=true
-	active=true
+        collisiondamage=2
+        enablecollisiondamage=true
+	      visible=true
+	      active=true
       >
       <attached>
@@ -361,4 +391,27 @@
     </Planet>
 
+    <!--TODO: Fix Enemies and their coordinates
+
+    <?lua
+      rows = 10
+      colomns = 10
+      for k = 1, rows, 1
+      do
+    ?>
+    <?lua
+      for i = 1, colomns, 1
+      do
+      x = -10000+k*100
+      y = -5000+i*100
+    ?>
+    <SpaceShip visible=false active=false name="Enemies" radarname="Attacker" position="<?lua print(y)?>,-4000,<?lua print(x)?>" lookat="0,0,0" team=1>
+        <templates>
+            <Template link="spaceshippirate" />
+        </templates>
+    </SpaceShip>
+    <?lua end ?>
+    <?lua end ?>
+  -->
+
     </Scene>
 </Level>