Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsAssff.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsAssff.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsAssff.oxi	(revision 10878)
@@ -45,5 +45,5 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=10 replenishamount=1 replenishinterval=0.5/>
+      <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=10 replenishamount=2 replenishinterval=7.5/>
       <LightningMunition initialmagazines=4 maxmagazines=4 munitionpermagazine=8 />
       <RocketMunition initialmagazines=5 maxmagazines=5 munitionpermagazine=1 />
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsAssff2.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsAssff2.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsAssff2.oxi	(revision 10878)
@@ -43,5 +43,5 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=10 replenishamount=1 replenishinterval=0.5/>
+      <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=10 replenishamount=1 replenishinterval=7.5/>
       <LightningMunition initialmagazines=4 maxmagazines=4 munitionpermagazine=8 />
       <RocketMunition initialmagazines=5 maxmagazines=5 munitionpermagazine=1 />
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsCollateral.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsCollateral.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsCollateral.oxi	(revision 10878)
@@ -47,5 +47,5 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=10 replenishamount=1 replenishinterval=0.5/>
+      <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=10 replenishamount=1 replenishinterval=7.5/>
       <LightningMunition initialmagazines=4 maxmagazines=4 munitionpermagazine=8 />
       <RocketMunition initialmagazines=5 maxmagazines=5 munitionpermagazine=1 />
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsEscort.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsEscort.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsEscort.oxi	(revision 10878)
@@ -27,4 +27,4 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=10 replenishamount=1 replenishinterval=0.5/>
+      <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=10 replenishamount=1 replenishinterval=7.5/>
     </munition>      
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsFPS.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsFPS.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsFPS.oxi	(revision 10878)
@@ -51,5 +51,5 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=5 replenishamount=1 replenishinterval=0.5/>
+      <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=5 replenishamount=1 replenishinterval=7.5/>
       <LightningMunition initialmagazines=2 maxmagazines=2 munitionpermagazine=8 />
     </munition>    
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsFPS_HS14.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsFPS_HS14.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsFPS_HS14.oxi	(revision 10878)
@@ -51,5 +51,5 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=5 replenishamount=1 replenishinterval=0.5/>
+      <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=5 replenishamount=1 replenishinterval=7.5/>
       <LightningMunition initialmagazines=2 maxmagazines=2 munitionpermagazine=8 />
     </munition>      
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsFS15.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsFS15.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsFS15.oxi	(revision 10878)
@@ -51,5 +51,5 @@
 </weaponpacks>
 <munition>
-  <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=10 replenishamount=1 replenishinterval=0.5/>
+  <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=10 replenishamount=1 replenishinterval=7.5/>
   <LightningMunition initialmagazines=4 maxmagazines=4 munitionpermagazine=8 />
   <RocketMunition initialmagazines=5 maxmagazines=5 munitionpermagazine=1 />
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsGhost.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsGhost.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsGhost.oxi	(revision 10878)
@@ -37,5 +37,5 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=10 replenishamount=1 replenishinterval=0.5/>
+      <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=10 replenishamount=1 replenishinterval=7.5/>
       <LightningMunition initialmagazines=4 maxmagazines=4 munitionpermagazine=8 />
       <RocketMunition initialmagazines=5 maxmagazines=5 munitionpermagazine=1 />
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsH2.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsH2.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsH2.oxi	(revision 10878)
@@ -44,5 +44,5 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=10 maxmagazines=10 munitionpermagazine=10 replenishamount=1 replenishinterval=0.5/>
+      <LaserMunition initialmagazines=10 maxmagazines=10 munitionpermagazine=10 replenishamount=1 replenishinterval=7.5/>
     </munition>
 
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsHXY.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsHXY.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsHXY.oxi	(revision 10878)
@@ -26,5 +26,5 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=10 maxmagazines=10 munitionpermagazine=10 replenishamount=1 replenishinterval=0.5/>
+      <LaserMunition initialmagazines=10 maxmagazines=10 munitionpermagazine=10 replenishamount=1 replenishinterval=7.5/>
       <LightningMunition initialmagazines=4 maxmagazines=4 munitionpermagazine=8 />
     </munition> 
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsHeartAttack.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsHeartAttack.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsHeartAttack.oxi	(revision 10878)
@@ -42,5 +42,5 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=20 maxmagazines=20 munitionpermagazine=10 replenishamount=1 replenishinterval=0.25/>
+      <LaserMunition initialmagazines=20 maxmagazines=20 munitionpermagazine=10 replenishamount=1 replenishinterval=6.0/>
       <LightningMunition initialmagazines=4 maxmagazines=4 munitionpermagazine=8 />
       <RocketMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=1 />
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsHeavyCruiser.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsHeavyCruiser.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsHeavyCruiser.oxi	(revision 10878)
@@ -45,5 +45,5 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=12 maxmagazines=12 munitionpermagazine=10 replenishamount=1 replenishinterval=0.3/>
+      <LaserMunition initialmagazines=12 maxmagazines=12 munitionpermagazine=10 replenishamount=1 replenishinterval=5.0/>
       <LightningMunition initialmagazines=4 maxmagazines=4 munitionpermagazine=8 />
       <RocketMunition initialmagazines=5 maxmagazines=5 munitionpermagazine=1 />
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsHeavyCruiserBody.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsHeavyCruiserBody.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsHeavyCruiserBody.oxi	(revision 10878)
@@ -47,5 +47,5 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=12 maxmagazines=12 munitionpermagazine=10 replenishamount=1 replenishinterval=0.3/>
+      <LaserMunition initialmagazines=12 maxmagazines=12 munitionpermagazine=10 replenishamount=1 replenishinterval=7.0/>
       <LightningMunition initialmagazines=4 maxmagazines=4 munitionpermagazine=8 />
       <RocketMunition initialmagazines=5 maxmagazines=5 munitionpermagazine=1 />
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsImmTest.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsImmTest.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsImmTest.oxi	(revision 10878)
@@ -57,5 +57,5 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=12 maxmagazines=12 munitionpermagazine=10 replenishamount=1 replenishinterval=0.3/>
+      <LaserMunition initialmagazines=12 maxmagazines=12 munitionpermagazine=10 replenishamount=1 replenishinterval=7.0/>
       <LightningMunition initialmagazines=4 maxmagazines=4 munitionpermagazine=8 />
       <RocketMunition initialmagazines=5 maxmagazines=5 munitionpermagazine=1 />
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsPirate.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsPirate.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsPirate.oxi	(revision 10878)
@@ -24,4 +24,4 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=12 maxmagazines=12 munitionpermagazine=10 replenishamount=1 replenishinterval=0.3/>
+      <LaserMunition initialmagazines=12 maxmagazines=12 munitionpermagazine=10 replenishamount=1 replenishinterval=7.0/>
     </munition>
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsRing.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsRing.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsRing.oxi	(revision 10878)
@@ -30,5 +30,5 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=12 maxmagazines=12 munitionpermagazine=10 replenishamount=1 replenishinterval=0.3/>
+      <LaserMunition initialmagazines=12 maxmagazines=12 munitionpermagazine=10 replenishamount=1 replenishinterval=7.5/>
       <GravityBombMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=1 />
       <IceMunition initialmagazines=16 maxmagazines=16 munitionpermagazine=1 />
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsSpacecruiser.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsSpacecruiser.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsSpacecruiser.oxi	(revision 10878)
@@ -89,5 +89,5 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=20 maxmagazines=20 munitionpermagazine=10 replenishamount=1 replenishinterval=0.2/>
+      <LaserMunition initialmagazines=20 maxmagazines=20 munitionpermagazine=10 replenishamount=1 replenishinterval=7.5/>
       <LightningMunition initialmagazines=4 maxmagazines=4 munitionpermagazine=8 />
       <RocketMunition initialmagazines=5 maxmagazines=5 munitionpermagazine=1 />
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsSwallow.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsSwallow.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsSwallow.oxi	(revision 10878)
@@ -25,5 +25,5 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=20 maxmagazines=20 munitionpermagazine=10 replenishamount=1 replenishinterval=0.5/>
+      <LaserMunition initialmagazines=20 maxmagazines=20 munitionpermagazine=10 replenishamount=1 replenishinterval=7.5/>
       <SplitMunition initialmagazines=4 maxmagazines=4 munitionpermagazine=8 />
     </munition>
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsTransporter.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsTransporter.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsTransporter.oxi	(revision 10878)
@@ -26,5 +26,5 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=20 maxmagazines=20 munitionpermagazine=10 replenishamount=1 replenishinterval=0.5/>
+      <LaserMunition initialmagazines=20 maxmagazines=20 munitionpermagazine=10 replenishamount=1 replenishinterval=7.5/>
       <LightningMunition initialmagazines=4 maxmagazines=4 munitionpermagazine=8 />
     </munition>
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsTurret.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsTurret.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsTurret.oxi	(revision 10878)
@@ -22,4 +22,4 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=10 replenishamount=1 replenishinterval=0.5/>
+      <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=10 replenishamount=1 replenishinterval=7.5/>
     </munition>
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsTurret1.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsTurret1.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsTurret1.oxi	(revision 10878)
@@ -22,4 +22,4 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=10 replenishamount=1 replenishinterval=0.5/>
+      <LaserMunition initialmagazines=8 maxmagazines=8 munitionpermagazine=10 replenishamount=1 replenishinterval=7.5/>
     </munition>
Index: code/branches/fabienHS15/data/levels/includes/weaponSettingsbigship.oxi
===================================================================
--- code/branches/fabienHS15/data/levels/includes/weaponSettingsbigship.oxi	(revision 10842)
+++ code/branches/fabienHS15/data/levels/includes/weaponSettingsbigship.oxi	(revision 10878)
@@ -48,5 +48,5 @@
     </weaponpacks>
     <munition>
-      <LaserMunition initialmagazines=12 maxmagazines=12 munitionpermagazine=10 replenishamount=1 replenishinterval=0.4/>
+      <LaserMunition initialmagazines=12 maxmagazines=12 munitionpermagazine=10 replenishamount=1 replenishinterval=7.5/>
       <LightningMunition initialmagazines=4 maxmagazines=4 munitionpermagazine=8 />
       <RocketMunition initialmagazines=5 maxmagazines=5 munitionpermagazine=1 />